import { Types as TypesChain } from "@rill/chain";
import { IncomingMessage, Server, ServerResponse, Types as HttpT } from "@rill/http";
import Rill from "./";
import { Context } from "./context";
export declare type Headers = HttpT.Headers;
export declare type SetupFunction = (app: Rill) => any;
export declare type SetupArg = SetupFunction | false | void;
export declare type NextFunction = TypesChain.NextFunction;
export declare type MiddlewareFunction = (ctx: Context, next?: NextFunction) => any;
export declare type MiddlewareArg = Stack | MiddlewareFunction | Rill | false | void;
export interface Stack extends Array<MiddlewareArg> {
    [index: number]: MiddlewareArg;
}
export declare type HttpRequestHandler = (this: Server, req: IncomingMessage, res?: ServerResponse) => any;
export declare type HttpListenHandler = (this: Server) => any;
export declare type MethodShortcut = (pathname: string | MiddlewareArg, ...middlewares: MiddlewareArg[]) => Rill;
export interface ListenOptions {
    ip?: string;
    port?: number;
    backlog?: number;
    tls?: any;
}
